function AttSizeStreamLisner() {
};

AttSizeStreamLisner.prototype = {
    mBytesRead : null,
    mStream : null,
    mCancel : false,
    mTimes  : 0,
    mAtt    : "",
    
    QueryInterface : function(iid)  {
        if (iid.equals(Components.interfaces.nsIStreamListener) ||
            iid.equals(Components.interfaces.nsISupports))
         return this;

        throw Components.results.NS_NOINTERFACE;
        return 0;
    },

    onStartRequest : function (aRequest, aContext) {
        this.mStream = Components.classes['@mozilla.org/binaryinputstream;1'].createInstance(Components.interfaces.nsIBinaryInputStream);
    },
    
    onStopRequest : function (aRequest, aContext, aStatusCode) {
        ABglobals.log('osr mTimes>' + this.mTimes);
        if (this.mCancel) return;
        try {
            if (this.mMsgUri == gDBView.URIForFirstSelectedMessage) {
                ABglobals.setAttSizeTextFor(this.mAttUrl,this.mBytesRead, false);
            }
        } catch (e) {}
        this.mAtt = "";
        this.mStream = null;
    },
    
    onDataAvailable : function (aRequest, aContext, aInputStream, aOffset, aCount) {
        if (this.mCancel) return;        
        try {
            if (this.mMsgUri != gDBView.URIForFirstSelectedMessage) {
                Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).
                    logStringMessage('attbytes - oda - uri change - aborting');
                aRequest.cancel(Components.results.NS_BINDING_ABORTED);
                this.mCancel = true;
                return;
            }
        } catch(e) {
            aRequest.cancel(Components.results.NS_BINDING_ABORTED);
            Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).
                logStringMessage('attbytes - oda - no uri - aborting');
            this.mCancel = true;
            return;

        }
        this.mStream.setInputStream(aInputStream);
        var chunk = this.mStream.readBytes(aCount);
        this.mAtt +=chunk;
        this.mBytesRead += aCount;
        this.mTimes ++
    }
}    

var ABglobals = {
    old_displayAttachmentsForExpandedView: null,
    pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
    prefInternal: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
                        .getBranch(null).QueryInterface(Components.interfaces.nsIPrefBranchInternal),
    sizesIn: "KiB",
    decPlaces: 2,
    order: 1,
    
    log: function(msg) {
        try {
            ABglobals.debug = ABglobals.pref.getBoolPref("attsizes.debug");
        } catch (e) {
            ABglobals.pref.setBoolPref("attsizes.debug",ABglobals.debug);
        }
        if (ABglobals.debug) {
            Components.classes["@mozilla.org/consoleservice;1"].
                getService(Components.interfaces.nsIConsoleService).
                logStringMessage("attSizes -" + msg);
        }
    },
    

    init: function() {
        ABglobals.old_displayAttachmentsForExpandedView = document.defaultView.displayAttachmentsForExpandedView;
        document.defaultView.displayAttachmentsForExpandedView = ABglobals.new_displayAttachmentsForExpandedView;
        try {
            ABglobals.prefInternal.addObserver('attsizes.', ABglobals.prefObserver, false); 
        } catch(e) {
        }
    },

    new_displayAttachmentsForExpandedView: function() {
        ABglobals.old_displayAttachmentsForExpandedView();
        for (index in currentAttachments) {
            var attachment = currentAttachments[index];
            setTimeout(ABglobals.setAttSizeFor,1,attachment);
        }
    },
    
    prefObserver: {
    	QueryInterface: function(iid) {
    		if (!iid.equals(Components.interfaces.nsISupports)
    				&& !iid.equals(Components.interfaces.nsISupportsWeakReference)
    				&& !iid.equals(Components.interfaces.nsIObserver)) {
    			throw Components.results.NS_ERROR_NO_INTERFACE; }
    		return this;
    	},
    	
    	removeObserver: function() {
    		ABglobals.prefInternal.removeObserver('attsizes.', this);
    	},
    	
    	observe: function(subject, topic, prefName) {
            ABglobals.log('prefObs, prefName >' + prefName + '<');
            ABglobals.setAttSizeTextFor("", "", true);
    	}
    },
    
    setAttSizeFor: function(attachment) {
        var mms = messenger.messageServiceFromURI(attachment.uri).
            QueryInterface(Components.interfaces.nsIMsgMessageService);
        var streamLisner = new AttSizeStreamLisner(); 
        streamLisner.mAttUrl = attachment.url;
        streamLisner.mMsgUri = attachment.uri;
        mms.openAttachment(attachment.contentType,
            attachment.displayName,
            attachment.url, 
            attachment.uri, 
            streamLisner, 
            null, 
            null);
    },

    setUnits: function(size) {
        var units = {decPlaces: ABglobals.decPlaces, sizesIn: ABglobals.sizesIn, sizesBy: Math.pow(2,10)};
        if (ABglobals.sizesIn == "kB") {
            units.sizesBy = Math.pow(10,3);
        }
        if (ABglobals.sizesIn == "mB") {
            units.sizesBy = Math.pow(10,6);
        }
        if (ABglobals.sizesIn == "MiB") {
            units.sizesBy = Math.pow(2,20);
        }
        if (ABglobals.sizesIn == "gB") {
            units.sizesBy = Math.pow(10,9);
        }
        if (ABglobals.sizesIn == "GiB") {
            units.sizesBy = Math.pow(2,30);
        }
        if (ABglobals.sizesIn.toUpperCase() == "AUTO") {
            var units = {decPlaces: 0, sizesIn: "bytes", sizesBy: 1};
            if (size > Math.pow(10,3) ) {
                units = {decPlaces: 1, sizesIn: "kB", sizesBy: Math.pow(10,3)};
            }
            if (size > Math.pow(10,6) ) {
                units = {decPlaces: 2, sizesIn: "mB", sizesBy: Math.pow(10,6)};
            }
            if (size > Math.pow(10,9) ) {
                units = {decPlaces: 2, sizesIn: "gB", sizesBy: Math.pow(10,9)};
            }
        }
        if (ABglobals.sizesIn.toUpperCase() == "AUTOB") {
            var units = {decPlaces: 0, sizesIn: "bytes", sizesBy: 1};
            if (size > Math.pow(2,10) ) {
                units = {decPlaces: 1, sizesIn: "KiB", sizesBy: Math.pow(2,10)};
            }
            if (size > Math.pow(2,20) ) {
                units = {decPlaces: 2, sizesIn: "MiB", sizesBy: Math.pow(2,20)};
            }
            if (size > Math.pow(2,30) ) {
                units = {decPlaces: 2, sizesIn: "GiB", sizesBy: Math.pow(2,30)};
            }
        }
        return units;
    },

    setAttSizeTextFor: function(attUrl, val, all) {
        ABglobals.log('setAttSizeTextFor, url' + attUrl + '< val>' + val);
        var attachmentList = document.getElementById('attachmentList');
        try {
            ABglobals.sizesIn = ABglobals.pref.getCharPref("attsizes.sizesIn");
        } catch (e) {
            ABglobals.pref.setCharPref("attsizes.sizesIn",ABglobals.sizesIn);
        }
        try {
            ABglobals.decPlaces = ABglobals.pref.getCharPref("attsizes.decimalPlaces");
        } catch (e) {
            ABglobals.pref.setCharPref("attsizes.decimalPlaces",ABglobals.decPlaces);
        }
        try {
            ABglobals.order = ABglobals.pref.getCharPref("attsizes.order");
        } catch (e) {
            ABglobals.pref.setCharPref("attsizes.order",ABglobals.order);
        }
        for (var i = 0; i < attachmentList.childNodes.length; i++) {
            if (all) {
                if (!attachmentList.childNodes[i].origlbl) attachmentList.childNodes[i].origlbl = attachmentList.childNodes[i].getAttribute("label");
                var units = ABglobals.setUnits(attachmentList.childNodes[i].attSize);        
                var siz = (attachmentList.childNodes[i].attSize/units.sizesBy).toFixed(units.decPlaces);
                var newlbl = attachmentList.childNodes[i].origlbl;
                if (ABglobals.order == 1) {
                    newlbl = '(' + siz + " " + units.sizesIn + ') ' + attachmentList.childNodes[i].origlbl;
                } 
                if (ABglobals.order == 2) {
                    newlbl = attachmentList.childNodes[i].origlbl + ' (' + siz + " " +  units.sizesIn + ')';
                } 
                attachmentList.childNodes[i].setAttribute("label", newlbl); 
            } else {
                if (attachmentList.childNodes[i].attachment.url == attUrl) {
                    if (!attachmentList.childNodes[i].origlbl) attachmentList.childNodes[i].origlbl = attachmentList.childNodes[i].getAttribute("label");
                    attachmentList.childNodes[i].attSize = val;
                    var units = ABglobals.setUnits(attachmentList.childNodes[i].attSize);        
                    var siz = (val/units.sizesBy).toFixed(units.decPlaces);
                    var newlbl = attachmentList.childNodes[i].origlbl;
                    if (ABglobals.order == 1) {
                        newlbl = '(' + siz + " " + units.sizesIn + ') ' + attachmentList.childNodes[i].origlbl;
                    } 
                    if (ABglobals.order == 2) {
                        newlbl = attachmentList.childNodes[i].origlbl + ' (' + siz + " " +  units.sizesIn + ')';
                    } 
                    
                    attachmentList.childNodes[i].setAttribute("label", newlbl); 
                    break;
                }
            }
        }
    }
}
addEventListener("load", ABglobals.init, false);
