var ATSglobals = {
    old_AddUrlAttachment: null,
    old_RemoveSelectedAttachment: null,
    pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
    prefInternal: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
                        .getBranch(null).QueryInterface(Components.interfaces.nsIPrefBranchInternal),
    sizesIn: "KiB",
    decPlaces: 2,
    order: 1,
    
    log: function(msg) {
        try {
            ATSglobals.debug = ATSglobals.pref.getBoolPref("attsizes.debug");
        } catch (e) {
            ATSglobals.pref.setBoolPref("attsizes.debug",ATSglobals.debug);
        }
        if (ATSglobals.debug) {
            Components.classes["@mozilla.org/consoleservice;1"].
                getService(Components.interfaces.nsIConsoleService).
                logStringMessage("attSizes " + msg);
        }
    },
    
    init: function() {
        var stff = AddUrlAttachment;
        stff = stff.toString();
        if (stff.indexOf('ATSglobals') == -1) {
            ATSglobals.old_AddUrlAttachment = document.defaultView.AddUrlAttachment;
            document.defaultView.AddUrlAttachment = ATSglobals.new_AddUrlAttachment;
        }
        var stff = RemoveSelectedAttachment;
        stff = stff.toString();
        if (stff.indexOf('ATSglobals') == -1) {
            ATSglobals.old_RemoveSelectedAttachment = document.defaultView.RemoveSelectedAttachment;
            document.defaultView.RemoveSelectedAttachment = ATSglobals.new_RemoveSelectedAttachment
        }
        ATSglobals.addSizes('',true); // this will populate the sizes for all attachments already there ( like on forwards. drafts and templates )
        var bucket = document.getElementById("attachmentBucket");
        try {
            ATSglobals.prefInternal.addObserver('attsizes.', ATSglobals.prefObserver, false); 
        } catch(e) {
        }
    },

    prefObserver: {
    	QueryInterface: function(iid) {
    		if (!iid.equals(Components.interfaces.nsISupports)
    				&& !iid.equals(Components.interfaces.nsISupportsWeakReference)
    				&& !iid.equals(Components.interfaces.nsIObserver)) {
    			throw Components.results.NS_ERROR_NO_INTERFACE; }
    		return this;
    	},
    	
    	removeObserver: function() {
    		ATSglobals.prefInternal.removeObserver('attsizes.', this);
    	},
    	
    	observe: function(subject, topic, prefName) {
            ATSglobals.log('prefObs, prefName >' + prefName + '<');
            ATSglobals.addSizes("", true);
    	}
    },
    
    onBucketChange: function(event) {
        ATSglobals.log('onBucketChange attr>' + event.attrName);
    },

    addSizes: function(attachment, noCheck) {
        var bucket = document.getElementById("attachmentBucket");
        try {
            ATSglobals.sizesIn = ATSglobals.pref.getCharPref("attsizes.sizesIn");
        } catch (e) {
            ATSglobals.pref.setCharPref("attsizes.sizesIn",ATSglobals.sizesIn);
        }
        try {
            ATSglobals.decPlaces = ATSglobals.pref.getCharPref("attsizes.decimalPlaces");
        } catch (e) {
            ATSglobals.pref.setCharPref("attsizes.decimalPlaces",ATSglobals.decPlaces);
        }
        try {
            ATSglobals.order = ATSglobals.pref.getCharPref("attsizes.order");
        } catch (e) {
            ATSglobals.pref.setCharPref("attsizes.order",ATSglobals.order);
        }
        for (var i = 0; i < bucket.childNodes.length; i++) {
            var item = bucket.childNodes[i];
            if (noCheck) {
                attachment = item.attachment
            }
            if (item.attachment == attachment) {
                var extr = '';
                var siz = 0;
                if (!item.origLabel) item.origLabel = item.getAttribute('label');
                try{
                    if (attachment.url.substring(0,7) == 'mailbox') {
                        var messenger = Components.classes['@mozilla.org/messenger;1'].createInstance();
                        messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
                        var msgHdr = messenger.messageServiceFromURI(attachment.url).messageURIToMsgHdr(attachment.url);
                        item.attSize = msgHdr.messageSize;
                        var units = ATSglobals.setUnits(item.attSize);
                        
                        siz = (msgHdr.messageSize/units.sizesBy).toFixed(units.decPlaces);
                        extr = '(' + siz + " " + units.sizesIn + ')'
                    } else {
                        // so get the file size here
                        var prothndlr = Components.classes["@mozilla.org/network/protocol;1?name=file"].createInstance(Components.interfaces.nsIFileProtocolHandler)
                        var fil = prothndlr.getFileFromURLSpec(attachment.url);
                        item.attSize = fil.fileSize;
                        var units = ATSglobals.setUnits(item.attSize);
                        siz = (fil.fileSize/units.sizesBy).toFixed(units.decPlaces);
                        extr = '(' + siz + " " + units.sizesIn + ')'
                        // then change the append item's label to include the size ...
                    }
                    if (ATSglobals.order == 1) {
                        item.setAttribute('label',extr + " " + item.origLabel);
                    } 
                    if (ATSglobals.order == 2) {
                        item.setAttribute('label', item.origLabel + " " + extr);
                    } 
                    
                    ATSglobals.attachmentRemoved();
                } catch(e) {
                    ATSglobals.log('err in attbytes e>' + e);

                }
            }
        }
    },

    setUnits: function(size) {
        var units = {decPlaces: ATSglobals.decPlaces, sizesIn: ATSglobals.sizesIn, sizesBy: Math.pow(2,10)};
        if (ATSglobals.sizesIn == "kB") {
            units.sizesBy = Math.pow(10,3);
        }
        if (ATSglobals.sizesIn == "mB") {
            units.sizesBy = Math.pow(10,6);
        }
        if (ATSglobals.sizesIn == "MiB") {
            units.sizesBy = Math.pow(2,20);
        }
        if (ATSglobals.sizesIn == "gB") {
            units.sizesBy = Math.pow(10,9);
        }
        if (ATSglobals.sizesIn == "GiB") {
            units.sizesBy = Math.pow(2,30);
        }
        if (ATSglobals.sizesIn.toUpperCase() == "AUTO") {
            var units = {decPlaces: 0, sizesIn: "bytes", sizesBy: 1};
            if (size > Math.pow(10,3) ) {
                units = {decPlaces: 1, sizesIn: "kB", sizesBy: Math.pow(10,3)};
            }
            if (size > Math.pow(10,6) ) {
                units = {decPlaces: 2, sizesIn: "mB", sizesBy: Math.pow(10,6)};
            }
            if (size > Math.pow(10,9) ) {
                units = {decPlaces: 2, sizesIn: "gB", sizesBy: Math.pow(10,9)};
            }
        }
        if (ATSglobals.sizesIn.toUpperCase() == "AUTOB") {
            var units = {decPlaces: 0, sizesIn: "bytes", sizesBy: 1};
            if (size > Math.pow(2,10) ) {
                units = {decPlaces: 1, sizesIn: "KiB", sizesBy: Math.pow(2,10)};
            }
            if (size > Math.pow(2,20) ) {
                units = {decPlaces: 2, sizesIn: "MiB", sizesBy: Math.pow(2,20)};
            }
            if (size > Math.pow(2,30) ) {
                units = {decPlaces: 2, sizesIn: "GiB", sizesBy: Math.pow(2,30)};
            }
        }
        return units;
    },

    attachmentRemoved: function() {
        var bucket = document.getElementById("attachmentBucket");
        var ttl = 0;
        for (var j=0; j < bucket.childNodes.length; j++) {
            ttl += parseFloat(bucket.childNodes[j].attSize)
        }
        var units = ATSglobals.setUnits(ttl);
        ttl = ttl/units.sizesBy;
        var s = "";
        var a = ""
        var totalWord = "";
        try {
            s = document.getElementById("attbytesBundle").getString('plural')
            a = document.getElementById("attbytesBundle").getString('attachment')
        } catch(e) {}
        try {
            totalWord = document.getElementById("attbytesBundle").getString('totalword')
        } catch(e) {}
        if (bucket.childNodes.length == 1) s = "";
        var tttext = bucket.childNodes.length + " " + a + s + ", " + ttl.toFixed(units.decPlaces) + " " + units.sizesIn + " " + totalWord;
        bucket.setAttribute('tooltiptext',tttext);
    },

    new_RemoveSelectedAttachment: function() {
        ATSglobals.old_RemoveSelectedAttachment();
        ATSglobals.attachmentRemoved();
    },
    
    new_AddUrlAttachment: function(attachment) {
        ATSglobals.old_AddUrlAttachment(attachment);
        ATSglobals.addSizes(attachment,false);
    }
}
addEventListener("load", ATSglobals.init, false);
